######################################################################
# @@HEADER3_NANAMI@@
######################################################################

package	Nana::HTTPCompress;
use 5.005;
use strict;
use vars qw($VERSION);
$VERSION = '0.1';

######################################################################

$gzip::path;
$gzip::header;

sub init {
	my($path)=@_;
	my $gzip_command='gzip';

	if($path eq 'nouse') {
		$path='';
	} elsif($path eq '') {
		my $forceflag="";
		my $fastflag="";
		foreach(split(/:/,$ENV{PATH})) {
			if(-x "$_/$gzip_command") {
				$path="$_/$gzip_command" ;
				if(open(PIPE,"$path --help 2>&1|")) {
					foreach(<PIPE>) {
						$forceflag="--force" if(/(\-\-force)/);
						$fastflag="--fast" if(/(\-\-fast)/);
					}
					close(PIPE);
				}
			}
		}
		if($path ne '') {
			$gzip::path="$path $fastflag $forceflag";
			$::debug.="auto detect gzip path : \"$gzip::path\"\n";	# debug
		} elsif(&load_module("Compress::Zlib")) {
			$gzip::path="zlib";
			$::debug.="auto detect Compress::Zlib";	# debug
		}
	}

	if ($path ne '') {
		if(($ENV{'HTTP_ACCEPT_ENCODING'}=~/gzip/)) {
			if($ENV{'HTTP_ACCEPT_ENCODING'}=~/x-gzip/) {
				$gzip::header="Content-Encoding: x-gzip\n";
			} else {
				$gzip::header="Content-Encoding: gzip\n";
			}
			return $gzip::header;
		}
	}
}

sub output {
	my ($data)=shift;
	if ($gzip::header ne '') {
		if($gzip::path eq "zlib") {
			binmode(STDOUT);
			my $compress_data=Compress::Zlib::memGzip ($data);
			print $compress_data;
		} else {
			binmode(STDOUT);
			open(STDOUT,"| $gzip::path");
			print $data;
		}
	} else {
		print $data;
	}
	close(STDOUT);
}
1;
__END__
