######################################################################
# multicomment.inc.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: multicomment.inc.pl,v 1.362 2012/04/11 21:31:07 papu Exp $
#
# "PyukiWiki" ver 0.2.1-alpha1-dev2 $$
# Author: Nekyo http://nekyo.qp.land.to/
# Copyright (C) 2004-2012 Nekyo
# http://nekyo.qp.land.to/
# Copyright (C) 2005-2012 PyukiWiki Developers Team
# http://pyukiwiki.info/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sfjp.jp/
# License: GPL3 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return:LF Code=UTF-8 1TAB=4Spaces
######################################################################

use strict;

# コメント欄の全体フォーマット
$multicomment::format = "\x08MSG\x08 -- \x08NAME\x08 \x08NOW\x08"
	if(!defined($comment::format));

# テキストエリアのカラム数
$multicomment::cols = 70
	if(!defined($multicomment::cols));
#
# テキストエリアの行数
$multicomment::rows = 5
	if(!defined($multicomment::rows));
#
# 名前、URL、メールアドレステキストエリアのカラム数
$multicomment::name_cols = 24
	if(!defined($multicomment::name_cols));
#
# その他題名テキストエリアのカラム数
$multicomment::text_cols = 60
	if(!defined($multicomment::text_cols));
#
# 名前の挿入フォーマット
$multicomment::name_format = "\'\'[[\$1>$::resource{profile_page}/\$1]]\'\'"
	if(!defined($multicomment::name_format));
#
# 日付の挿入フォーマット (&new で認識できること)
$multicomment::date_format= "Y-m-d(lL) H:i:s"
	if(!defined($multicomment::date_format));
#
# 挿入する位置 1:欄の前 0:欄の後
$multicomment::ins = 0
	if(!defined($multicomment::ins));
#
# 書込み下に一行コメントを 1:入れる 0:入れない
$multicomment::comment = 1
	if(!defined($multicomment::comment));
#
# 改行を自動的変換 1:する 0:しない
$multicomment::auto_br = 1
	if(!defined($multicomment::auto_br));
#
# 名前なしで処理しない
$multicomment::noname = 1
	if(!defined($multicomment::noname));

######################################################################

$multicomment::no = 0;

my $_no_name = "";

sub plugin_multicomment_action {
	my $name_form;
	my $textarea_form;
	foreach(keys %::form) {
		if(/^\_ext\_(name|text|textarea)/) {
			&::spam_filter($::form{$_}, 2, $::chk_multicomment_uri_count, $::chk_multicomment_mail_count);
		}
		if(/^\_ext\_(name|textarea)/) {
			if($::form{$_}=~/^\s*$/) {
				return('msg'=>"$::form{mypage}\t\t$::resource{multicomment_plugin_err}",'body'=>&text_to_html($::database{$::form{mypage}}),'ispage'=>1);
			}
		}
		$::form{$_}=&code_convert(\$::form{$_}, $::defaultcode);
		$name_form=$_ if(/^\_ext\_name\_/);
		$textarea_form=$_ if(/^\_ext\_textarea\_/);

		if(/^\_ext\_textarea\_/) {
			$::form{$_}=~s/\x0D\x0A|\x0D|\x0A/\n/g;
			$::form{$_}=~s/^(\s|\n)//g while($::form{$_}=~/^(\s|\n)/);
			$::form{$_}=~s/(\s|\n)$//g while($::form{$_}=~/(\s|\n)$/);
			$::form{$_}=~s/\n/\~\n/g if($multicomment::auto_br);
		}
	}

	my $name = $_no_name;
	if ($::form{$name_form} ne '') {
		$name = $multicomment::name_format;
		$name =~ s/\$1/$::form{$name_form}/g;
	}

	my $msg=$::form{$textarea_form};

	my $url;
	my $mail;
	for(my $i=1; $::form{"_ext_hidden\_$i"} ne ""; $i++) {
		foreach my $ffname("url","mail") {
			if($::form{"_ext\_$ffname\_$i"} ne "") {
				if($ffname eq "url") {
					if($::form{"_ext\_$ffname\_$i"}=~/$::isurl/g) {
						$url=qq([[HOME>$::form{"_ext\_$ffname\_$i"}]]);
					}
				} elsif($ffname eq "mail") {
					if($::form{"_ext\_$ffname\_$i"}=~/$::ismail/g) {
						$mail=qq([[MAIL>mailto:$::form{"_ext\_$ffname\_$i"}]]);
					}
				}
			}
		}
	}

	my $now="&new{@{[&date($multicomment::date_format)]}};";
	my $comment = $comment::format;
	$comment =~ s/\x08MSG\x08/$msg/;
	$comment =~ s/\x08NAME\x08/$name $url $mail/;
	$comment =~ s/\x08NOW\x08/$now/;
	$comment = "-" . $comment;

	my $postdata = '';
	my @postdata_old = split(/\r?\n/, $::database{$::form{'mypage'}});
	my $_multicomment_no = 0;

	foreach (@postdata_old) {
		$postdata .= $_ . "\n" if (!$multicomment::ins);
		if (/^#multicomment/ && (++$_multicomment_no == $::form{multicomment_no})) {
			$postdata .= "$comment\n";
		}
		$postdata .= $_ . "\n" if ($multicomment::ins);
	}
	$::form{mymsg} = $postdata;
	$::form{mytouch} = 'on';
	&do_write("FrozenWrite");
	&close_db;
	exit;
}

sub plugin_multicomment_convert {
	my(@args)=split(/,/,&htmlspecialchars(shift));

	return ' '
		if($::writefrozenplugin eq 0 && &get_info($::form{mypage}, $::info_IsFrozen) eq 1);
	$multicomment::no++;
	my $conflictchecker = &get_info($::form{mypage}, $::info_ConflictChecker);

	my $captcha_form;
	eval {
		$captcha_form=&plugin_captcha_form;
	};

	my $form="<table>";
	my $formname=0;
	foreach my $arg(@args) {
		$formname++;
		my($type, $text, $opt)=split(/=/,$arg);
		if($type=~/^(comment)/) {
			$form.=<<EOM;
<input type="hidden" name="_ext\_$type\_$formname" value="$text" />
EOM
		}
		if($type=~/^(text|name|url|mail|subject)$/) {
			$form.=<<EOM;
<input type="hidden" name="_ext_hidden_$formname" value="$text" />
<tr><td>$text : </td><td><input type="text" name="_ext\_$type\_$formname" size="@{[$type=~/text/ ? $multicomment::text_cols : $type=~/name|url|mail/ ? $multicomment::name_cols : $multicomment::subject_cols]}" value="$opt" /></td></tr>
EOM
		}
		if($type eq "star") {
			$form.=<<EOM;
<input type="hidden" name="_ext_hidden_$formname" value="$text" />
<tr><td>$text : </td><td><select name="_ext_star_$formname">
<option value="0">$::resource{multicomment_plugin_star0}</option>
<option value="1">$::resource{multicomment_plugin_star1}</option>
<option value="2" >$::resource{multicomment_plugin_star2}</option>
<option value="3">$::resource{multicomment_plugin_star3}</option>
<option value="4">$::resource{multicomment_plugin_star4}</option>
<option value="5">$::resource{multicomment_plugin_star5}</option>
</select></td></tr>
EOM
		}
		if($type eq "select") {
			$form.=<<EOM;
<input type="hidden" name="_ext_hidden_$formname" value="$text" />
<tr><td>$text : </td><td><select name="_ext_select_$formname">
EOM
			foreach(split(/\|/,$opt)) {
				$form.=<<EOM;
<option value="$_">$_</option>
EOM
			}
			$form.=<<EOM;
</select>
</td></tr>
EOM
		}
		if($type eq "checkbox") {
			$form.=<<EOM;
<input type="hidden" name="_ext_hidden_$formname" value="$text" />
<tr><td>&nbsp;</td><td>
<input type="checkbox" name="_ext_checkbox_$formname" value="on"@{[$opt eq "checked" ? ' checked="checked"' : ""]} />$text</td></tr>
EOM
		}
		if($type eq "textarea") {
			$form.=<<EOM;
<input type="hidden" name="_ext_hidden_$formname" value="$text" />
<tr><td>$text : </td><td>
<textarea name="_ext_textarea_$formname" rows="$multicomment::rows" cols="$multicomment::cols"></textarea></td></tr>
EOM
		}
	}
	$form.=<<EOM;
<tr><td>&nbsp;</td><td>
$captcha_form
<input type="submit" value="$::resource{multicomment_plugin_btn}" />
<input type="reset" value="$::resource{multicomment_plugin_clear}" />
</td></tr>
</table>
EOM
	return <<"EOD";
<form action="$::script" method="post">
<div>
<input type="hidden" name="multicomment_no" value="$multicomment::no" />
<input type="hidden" name="cmd" value="multicomment" />
<input type="hidden" name="mypage" value="$::form{'mypage'}" />
<input type="hidden" name="myConflictChecker" value="$conflictchecker" />
<input type="hidden" name="mytouch" value="on" />
$form
</div>
</form>
EOD
}

1;
__END__

=head1 NAME

multicomment.inc.pl - PyukiWiki Plugin

=head1 SYNOPSIS

 #multicomment

=head1 DESCRIPTION

A like of BBS plugin

=head1 SETTING

=head2 pyukiwiki.ini.cgi

=over 4

=item $::writefrozenplugin

write frozen page

=back

=head2 multicomment.inc.pl

=over 4

=item $multicomment::cols

textarea colum

=item  $multicomment::rows

textarea row

=item $multicomment::name_cols

name text area colum

=item $multicomment::subject_cols

subject text area colum

=item $multicomment::name_format

name addtion format

=item $multicomment::subject_format

subject addtion format

=item $multicomment::ins

insert place (1:before, 0:after)

=item $multicomment::comment

insert comment plugin

=item $multicomment::auto_br

auto break

=item $multicomment::noname

do error of no name

=item $multicomment::nosubject

do error of no subject

=back

=head1 SEE ALSO

=over 4

=item PyukiWiki/Plugin/Standard/multicomment

L<http://pyukiwiki.info/PyukiWiki/Plugin/Standard/multicomment/>

=item PyukiWiki CVS

L<http://sfjp.jp/cvs/view/pyukiwiki/PyukiWiki-Devel/plugin/multicomment.inc.pl?view=log>

L<http://sfjp.jp/cvs/view/pyukiwiki/PyukiWiki-Devel-UTF8/plugin/multicomment.inc.pl?view=log>

=back

=head1 AUTHOR

=over 4

=item Nekyo

L<http://nekyo.qp.land.to/>

=item PyukiWiki Developers Team

L<http://pyukiwiki.info/>

=back

=head1 LICENSE

Copyright (C) 2004-2012 by Nekyo.

Copyright (C) 2005-2012 by PyukiWiki Developers Team

License is GNU GENERAL PUBLIC LICENSE 3 and/or Artistic 1 or each later version.

This program is free software; you can redistribute it and/or
modify it under the same terms as Perl itself.

=cut
